local NekoLoot = LibStub("AceAddon-3.0"):GetAddon("NekoLoot")
local unpack = unpack

local backdrop = {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
	insets = {left = 4, right = 4, top = 4, bottom = 4},
}

local gradientOn = {"VERTICAL", .1, .1, .1, 0, .25, .25, .25, 1}
local gradientOff = {"VERTICAL", 0, 0, 0, 1, 0, 0, 0, 1}

-- Hintergrund
function NekoLoot:BackdropFrame(frame, backgroundcolor, bordercolor)
	frame:SetBackdrop(
		{
			bgFile = "Interface\\Tooltips\\UI-Tooltip-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", 
			tile = true, tileSize = 32, edgeSize = 15, 
			insets = { left = 4, right = 4, top = 4, bottom = 4 }
		}
	)
	frame:SetBackdropColor( unpack( backgroundcolor))
	frame:SetBackdropBorderColor( unpack( bordercolor))
end

function NekoLoot:Skin(frame, backgroundcolor, bordercolor)
	if not frame.tfade then 
		frame.tfade = frame:CreateTexture(nil, "BORDER")
	end
	
	frame:SetBackdrop(backdrop)
	frame:SetBackdropColor(unpack(backgroundcolor))
	frame:SetBackdropBorderColor(unpack(bordercolor))

	frame.tfade:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	frame.tfade:SetPoint("TOPLEFT", frame, "TOPLEFT", 4, -4)
	frame.tfade:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -4, 4) 

	frame.tfade:SetBlendMode("ADD")
	frame.tfade:SetGradientAlpha(unpack(gradientOn)) 
end

function NekoLoot:QualityBorder(button)
	local frame = button.wrapper or button
	local border = frame:CreateTexture(button:GetName() .. "QualBorder", "OVERLAY")
	border:SetTexture("Interface\\Buttons\\UI-ActionButton-Border")
	border:SetBlendMode("ADD")
	border:SetAlpha(0.5)
	border:SetHeight(button:GetHeight() * 1.8)
	border:SetWidth(button:GetWidth() * 1.8)
	border:SetPoint("CENTER", frame, "CENTER", 0, 1)
	border:Hide()
	return border
end

function NekoLoot:ItemButtonWrapper(button, widthOff, heightOff, edgeSize)
	local wrapper = button.wrapper or CreateFrame("Frame", button:GetName().."Wrapper", button)
	wrapper:SetWidth(button:GetWidth() + ( widthOff or 10))
	wrapper:SetHeight(button:GetHeight() + ( heightOff or 10))
	wrapper:ClearAllPoints()
	wrapper:SetPoint("CENTER", button, "CENTER")
	
	-- TODO: what the hell come these colors from?
	self:Skin(wrapper, {1, 1, 1, 0}, {.7, .7, .7, 1})
	
	if edgeSize then
		local backdrop = wrapper:GetBackdrop()
		backdrop.edgeSize = edgeSize
		wrapper:SetBackdrop(backdrop)
	end
	
	wrapper:Show()
	return wrapper
end